package be.ac.ulb.code.wit.service;

import be.ac.ulb.code.wit.contacts.Contact;
import be.ac.ulb.code.wit.contacts.ContactGroup;

public class GroupServiceImpl extends Object implements GroupService {

	@Override
	public Contact[] getGroupContacts(String name) throws NoSuchGroupException {
		ContactGroup group = ContactGroup.FindByName(name);
		if (group == null) throw new NoSuchGroupException("Could not find group " + name);
		return group.contacts.toArray(new Contact[0]);
	}

	@Override
	public void addContactToGroup(Contact c, String name) throws NoSuchGroupException, NoSuchContactException {
		ContactGroup group = ContactGroup.FindByName(name);
		if (group == null) throw new NoSuchGroupException("Could not find group " + name);
	
		// Use a contact we know
		Contact contact = Contact.FindByEmail(c.email);
		if (contact == null) throw new NoSuchContactException("Could not find contact " + c.email);
		
		group.addContact(contact);
		group.save();
	}

	@Override
	public void removeContactFromGroup(Contact c, String name) throws NoSuchContactException, NoSuchGroupException {
		ContactGroup group = ContactGroup.FindByName(name);
		if (group == null) throw new NoSuchGroupException("Could not find group " + name);
		
		// Use a contact we know
		Contact contact = Contact.FindByEmail(c.email);
		if (contact == null) throw new NoSuchContactException("Could not find contact " + c.email);

		group.removeContact(contact);
	}

}
